import { OT, pipe, T } from '@contentlayer/utils/effect';
import { getFieldData } from '../mapping/index.js';
import { fetchPageContent } from '../notion/fetchPageContent.js';
export const makeDocument = ({ documentTypeDef, databaseTypeDef, page, options }) => pipe(T.forEachParDict_(documentTypeDef.fieldDefs.filter((f) => !f.isSystemField), {
    mapKey: (fieldDef) => T.succeed(fieldDef.name),
    mapValue: (fieldDef) => {
        const databaseFieldTypeDef = databaseTypeDef.properties?.find((field) => field.key === fieldDef.propertyKey);
        return getFieldData({
            fieldDef,
            property: page.properties[fieldDef.propertyKey],
            databaseFieldTypeDef,
            databaseTypeDef,
            documentTypeDef,
        });
    },
}), T.chain((docValues) => T.gen(function* ($) {
    const document = {
        ...docValues,
        [options.fieldOptions.typeFieldName]: documentTypeDef.name,
        _id: page.id,
        _raw: {},
        ...(databaseTypeDef.importContent !== false
            ? {
                [options.fieldOptions.bodyFieldName]: {
                    html: yield* $(fetchPageContent({ page })),
                },
            }
            : {}),
    };
    return document;
})), OT.withSpan('@contentlayer/source-notion/fetchData:makeDocument'));
//# sourceMappingURL=makeDocument.js.map