import { T } from '@contentlayer/utils/effect';
export const fieldPeople = {
    getFieldDef: () => T.succeed({
        type: 'list',
        of: {
            type: 'nested',
            nestedTypeName: 'User',
        },
        default: [],
    }),
    getFieldData: ({ propertyData }) => T.succeed(propertyData.map((user) => ({
        type: user.type,
        name: user.name,
        avatarUrl: user.avatar_url,
        ...('person' in user
            ? {
                email: user.person.email,
            }
            : {}),
        ...('bot' in user
            ? {
                workspace: user.bot.workspace_name,
            }
            : {}),
    }))),
};
//# sourceMappingURL=field-people.js.map