import { OT, pipe, T } from '@contentlayer/utils/effect';
import { provideDocumentTypeDef } from './provideDocumentTypeDef.js';
import { flattendDatabaseTypeDef } from './utils/flattenDatabaseTypeDef.js';
export const provideDocumentTypeDefMap = ({ databaseTypeDefs, options }) => pipe(T.gen(function* ($) {
    const documentTypeDefMap = {};
    const getDocumentTypeDef = (databaseTypeDef) => {
        return databaseTypeDef.name in documentTypeDefMap
            ? T.succeed(documentTypeDefMap[databaseTypeDef.name])
            : pipe(provideDocumentTypeDef({
                databaseTypeDef: flattendDatabaseTypeDef(databaseTypeDef),
                getDocumentTypeDef,
                options,
            }), T.tap((documentTypeDef) => T.succeed((documentTypeDefMap[databaseTypeDef.name] = documentTypeDef))));
    };
    for (const databaseTypeDef of databaseTypeDefs) {
        yield* $(getDocumentTypeDef(databaseTypeDef));
    }
    return documentTypeDefMap;
}), OT.withSpan('@contentlayer/source-notion/schema:provideDocumentTypeDefMap'));
//# sourceMappingURL=provideDocumentTypeDefMap.js.map