import { OT, pipe, T } from '@contentlayer/utils/effect';
import { getFieldDef } from '../mapping/index.js';
import { findDatabaseFieldDef } from './utils/findDatabaseFieldDef.js';
import { normalizeKey } from './utils/normalizeKey.js';
export const provideFieldDef = ({ property, databaseTypeDef, getDocumentTypeDef }) => pipe(T.succeed(findDatabaseFieldDef({ databaseTypeDef, property })), T.chain((databaseFieldTypeDef) => T.gen(function* ($) {
    const name = databaseFieldTypeDef?.key ?? normalizeKey(property.name);
    return {
        ...(yield* $(getFieldDef({ property, databaseFieldTypeDef, databaseTypeDef, getDocumentTypeDef }))),
        name,
        propertyKey: property.name,
        isSystemField: false,
        description: databaseFieldTypeDef?.description,
        isRequired: databaseFieldTypeDef?.required ?? false,
    };
})), OT.withSpan('@contentlayer/source-notion/schema:provideFieldDef'));
//# sourceMappingURL=provideFieldDef.js.map